/*
 * lzma_exports.h - internal header with definitions of all exported functions
 *
 * Copyright (C) 2019 Thorsten Otto
 *
 * For conditions of distribution and use, see LICENSE.
 */

#ifndef LIBFUNC
#error "LIBFUNC must be defined before including this file"
#endif
#ifndef LIBFUNC2
#define LIBFUNC2(_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#endif
#ifndef LIBFUNCRET64
#define LIBFUNCRET64(_fn, orig_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#endif
#ifndef LIBFUNC2RET64
#define LIBFUNC2RET64(_fn, orig_fn, name, _nargs) LIBFUNC2(_fn, name, _nargs)
#endif
			  /* Atari specific functions */
	LIBFUNC(lzma_slb_control, 2)

/* Basic features */
	LIBFUNC(lzma_version_number, 0)
	LIBFUNC(lzma_version_string, 0)
	LIBFUNC(lzma_code, 2)
	LIBFUNC(lzma_end, 1)
	LIBFUNC(lzma_get_progress, 1)
	LIBFUNC(lzma_memusage, 1)
	LIBFUNC(lzma_memlimit_get, 1)
	LIBFUNC(lzma_memlimit_set, 3)
	LIBFUNC(lzma_vli_encode, 6)
	LIBFUNC(lzma_vli_decode, 5)
	LIBFUNC(lzma_vli_size, 2)
	LIBFUNC(lzma_check_is_supported, 1)
	LIBFUNC(lzma_check_size, 1)
	LIBFUNC(lzma_crc32, 3)
	LIBFUNC(lzma_crc64_gnuc, 3)
	LIBFUNC(lzma_get_check, 1)

/* Filters */
	LIBFUNC(lzma_filter_encoder_is_supported, 1)
	LIBFUNC(lzma_filter_decoder_is_supported, 1)
	LIBFUNC(lzma_filters_copy, 3)
	LIBFUNC(lzma_raw_encoder_memusage, 1)
	LIBFUNC(lzma_raw_decoder_memusage, 1)
	LIBFUNC(lzma_raw_encoder, 2)
	LIBFUNC(lzma_raw_decoder, 2)
	LIBFUNC(lzma_filters_update, 2)
	LIBFUNC(lzma_raw_buffer_encode, 7)
	LIBFUNC(lzma_raw_buffer_decode, 8)
	LIBFUNC(lzma_properties_size, 2)
	LIBFUNC(lzma_properties_encode, 2)
	LIBFUNC(lzma_properties_decode, 4)
	LIBFUNC(lzma_filter_flags_size, 2)
	LIBFUNC(lzma_filter_flags_encode, 4)
	LIBFUNC(lzma_filter_flags_decode, 5)
	LIBFUNC(lzma_mf_is_supported, 1)
	LIBFUNC(lzma_mode_is_supported, 1)
	LIBFUNC(lzma_lzma_preset, 2)

/* Container formats */
	LIBFUNC(lzma_easy_decoder_memusage, 1)
	LIBFUNC(lzma_easy_encoder, 3)
	LIBFUNC(lzma_easy_buffer_encode, 8)
	LIBFUNC(lzma_stream_encoder, 3)
#ifdef COND_THREADS
	LIBFUNC(lzma_stream_encoder_mt_memusage, 1)
	LIBFUNC(lzma_stream_encoder_mt, 2)
#else
	NOFUNC
	NOFUNC
#endif
	LIBFUNC(lzma_alone_encoder, 2)
	LIBFUNC(lzma_stream_buffer_bound, 1)
	LIBFUNC(lzma_stream_buffer_encode, 8)
	LIBFUNC(lzma_stream_decoder, 3)
	LIBFUNC(lzma_auto_decoder, 3)
	LIBFUNC(lzma_alone_decoder, 3)
	LIBFUNC(lzma_stream_buffer_decode, 9)

/* Advanced features */
	LIBFUNC(lzma_stream_header_encode, 2)
	LIBFUNC(lzma_stream_footer_encode, 2)
	LIBFUNC(lzma_stream_header_decode, 2)
	LIBFUNC(lzma_stream_footer_decode, 2)
	LIBFUNC(lzma_stream_flags_compare, 2)
	LIBFUNC(lzma_block_header_size, 1)
	LIBFUNC(lzma_block_header_encode, 2)
	LIBFUNC(lzma_block_header_decode, 3)
	LIBFUNC(lzma_block_compressed_size, 2)
	LIBFUNC(lzma_block_unpadded_size_gnuc, 1)
	LIBFUNC(lzma_block_total_size_gnuc, 1)
	LIBFUNC(lzma_block_encoder, 2)
	LIBFUNC(lzma_block_decoder, 2)
	LIBFUNC(lzma_block_buffer_bound, 1)
	LIBFUNC(lzma_block_buffer_encode, 7)
	LIBFUNC(lzma_block_uncomp_encode, 6)
	LIBFUNC(lzma_block_buffer_decode, 8)
	LIBFUNC(lzma_index_memusage, 4)
	LIBFUNC(lzma_index_memused, 1)
	LIBFUNC(lzma_index_init, 1)
	LIBFUNC(lzma_index_end, 2)
	LIBFUNC(lzma_index_append, 6)
	LIBFUNC(lzma_index_stream_flags, 2)
	LIBFUNC(lzma_index_checks, 1)
	LIBFUNC(lzma_index_stream_padding, 3)
	LIBFUNC(lzma_index_stream_count_gnuc, 1)
	LIBFUNC(lzma_index_block_count_gnuc, 1)
	LIBFUNC(lzma_index_size_gnuc, 1)
	LIBFUNC(lzma_index_stream_size_gnuc, 1)
	LIBFUNC(lzma_index_total_size_gnuc, 1)
	LIBFUNC(lzma_index_file_size_gnuc, 1)
	LIBFUNC(lzma_index_uncompressed_size_gnuc, 1)
	LIBFUNC(lzma_index_iter_init, 2)
	LIBFUNC(lzma_index_iter_rewind, 1)
	LIBFUNC(lzma_index_iter_next, 2)
	LIBFUNC(lzma_index_iter_locate, 3)
	LIBFUNC(lzma_index_cat, 3)
	LIBFUNC(lzma_index_dup, 2)
	LIBFUNC(lzma_index_encoder, 2)
	LIBFUNC(lzma_index_decoder, 4)
	LIBFUNC(lzma_index_buffer_encode, 4)
	LIBFUNC(lzma_index_buffer_decode, 6)
	LIBFUNC(lzma_index_hash_init, 2)
	LIBFUNC(lzma_index_hash_end, 2)
	LIBFUNC(lzma_index_hash_append, 5)
	LIBFUNC(lzma_index_hash_decode, 4)
	LIBFUNC(lzma_index_hash_size_gnuc, 1)

/* Hardware information */
	LIBFUNC(lzma_physmem, 0)
#ifdef COND_THREADS
	LIBFUNC(lzma_cputhreads, 0)
#else
	NOFUNC
#endif

	/* extra pure-c wrappers */
	LIBFUNCRET64(15, lzma_crc64_purec, 4)
	LIBFUNCRET64(58, lzma_block_unpadded_size_purec, 2)
	LIBFUNCRET64(59, lzma_block_total_size_purec, 2)
	LIBFUNCRET64(74, lzma_index_stream_count_purec, 2)
	LIBFUNCRET64(75, lzma_index_block_count_purec, 2)
	LIBFUNCRET64(76, lzma_index_size_purec, 2)
	LIBFUNCRET64(77, lzma_index_stream_size_purec, 2)
	LIBFUNCRET64(78, lzma_index_total_size_purec, 2)
	LIBFUNCRET64(79, lzma_index_file_size_purec, 2)
	LIBFUNCRET64(80, lzma_index_uncompressed_size_purec, 2)
	LIBFUNCRET64(95, lzma_index_hash_size_purec, 2)

#undef LIBFUNC
#undef LIBFUNC2
#undef LIBFUNCRET64
#undef LIBFUNC2RET64
#undef NOFUNC
