/*
 * libclose.c - loader for library
 *
 * Copyright (C) 2019 Thorsten Otto
 */
#include "slb/lzma.h"
#include <stdio.h>
#include <mint/mintbind.h>
#include <time.h>
#include "libstrct.h"
#include "slbload.h"

#if defined(__PUREC__)
struct lzma_index_hash_s { int dummy; };
struct lzma_index_s { int dummy; };
struct lzma_internal_s { int dummy; };
#endif




static long __CDECL slb_unloaded(SLB_HANDLE slb, long fn, short nwords, ...)
{
	(void)slb;
	(void)fn;
	(void)nwords;
	(void) Cconws(LZMA_SHAREDLIB_NAME " was already unloaded\r\n");
	Pterm(1);
	return -32;
}


void slb_lzma_close(void)
{
	SLB *lzma = slb_lzma_get();

	if (!lzma)
		return;
	if (lzma->handle)
	{
		slb_unload(lzma->handle);
		lzma->handle = 0;
	}
	lzma->exec = slb_unloaded;
}
