/*
 * libslb.h - internal header file.
 * Used only when compiling the shared library code,
 * to redirect standard library functions to the
 * library that was linked to the application
 *
 * Copyright (C) 2019 Thorsten Otto
 */

#ifndef __LZMASLB_H__
#define __LZMASLB_H__ 1

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <setjmp.h>

#undef memset
#undef memcpy
#undef memcmp
#undef memmove

#undef strlen
#undef strcpy
#undef strcmp

#undef malloc
#undef free

#include "libstrct.h"

#define memset(d, c, l) lzma_get_slb_funcs()->p_memset(d, c, l)
#define memcpy(d, s, l) lzma_get_slb_funcs()->p_memcpy(d, s, l)
#define memmove(d, s, l) lzma_get_slb_funcs()->p_memcpy(d, s, l)
#define memcmp(d, s, l) lzma_get_slb_funcs()->p_memcmp(d, s, l)

#define strlen lzma_get_slb_funcs()->p_strlen
#define strcpy lzma_get_slb_funcs()->p_strcpy
#define strcmp lzma_get_slb_funcs()->p_strcmp

#define malloc lzma_get_slb_funcs()->p_malloc
#define free(p) lzma_get_slb_funcs()->p_free(p)

#endif /* __LZMASLB_H__ */
