/*
 *
 *  \file       memusage.c
 *  \brief      Calculates memory usage using lzma_memory_usage()
 *
 *  Author:     Lasse Collin
 *
 *  This file has been put into the public domain.
 *  You can do whatever you want with this file.
 */

#include "sysdefs.h"
#include "lzma.h"
#include <stdio.h>

int
main(void)
{
	lzma_options_lzma lzma = {
		(1U << 30) + (1U << 29),
		NULL,
		0,
		3,
		0,
		2,
		LZMA_MODE_NORMAL,
		48,
		LZMA_MF_BT4,
		0,
		0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 0
	};

#if 0
	lzma_options_filter filters[] = {
		{ LZMA_FILTER_LZMA1_C,
			(lzma_options_lzma *)&lzma_preset_lzma[6 - 1] },
		{ UINT64_MAX, NULL }
	};
#endif
	lzma_filter filters[] = {
		{ LZMA_FILTER_LZMA1_C, &lzma },
		{ LZMA_UINT64_MAX, NULL }
	};

	printf("Encoder: %10" LZMA_PRIMEM " B\n",
			lzma_raw_encoder_memusage(filters));
	printf("Decoder: %10" LZMA_PRIMEM " B\n",
			lzma_raw_decoder_memusage(filters));

	return 0;
}
