/*
 *  \file       tkgettxt.h
 *  \brief      Wrapper for gettext and friends
 *
 *  Author:     Lasse Collin
 *
 *  This file has been put into the public domain.
 *  You can do whatever you want with this file.
 */

#ifndef TUKLIB_GETTEXT_H
#define TUKLIB_GETTEXT_H

#include "tkcommon.h"
#include <locale.h>

#ifndef TUKLIB_GETTEXT
#	ifdef ENABLE_NLS
#		define TUKLIB_GETTEXT 1
#	else
#		define TUKLIB_GETTEXT 0
#	endif
#endif

#if TUKLIB_GETTEXT
#	include <libintl.h>
#	define tuklib_gettext_init(package, localedir) \
		do { \
			setlocale(LC_ALL, ""); \
			bindtextdomain(package, localedir); \
			textdomain(package); \
		} while (0)
#	define _(msgid) gettext(msgid)
#else
#if defined(__atarist__) || defined(__TOS__)
    /* mintlib does not have a real setlocale */
#	define tuklib_gettext_init(package, localedir)
#else
#	define tuklib_gettext_init(package, localedir) setlocale(LC_ALL, "")
#endif
#	define _(msgid) (msgid)
#	define ngettext(msgid1, msgid2, n) ((n) == 1 ? (msgid1) : (msgid2))
#endif
#define N_(msgid) msgid

#endif
