/*
 *
 *  \file       vli_size.c
 *  \brief      Calculates the encoded size of a variable-length integer
 *
 *  Author:     Lasse Collin
 *
 *  This file has been put into the public domain.
 *  You can do whatever you want with this file.
 */

#include "common.h"

#ifdef __PUREC__
struct lzma_index_hash_s { int dummy; };
struct lzma_index_s { int dummy; };
#endif


#if !LL_HAVE_UINT64
ll_uint64_t LZMA_VLI_MAX = LL_UINT64_C(0x7fffffffUL, 0xffffffffUL);
#endif


LZMA_API(uint32_t) lzma_vli_size(lzma_vli vli)
{
	uint32_t i;
	
	if (ll_uint64_gt(vli, LZMA_VLI_MAX))
		return 0;

	i = 0;
	do {
		vli = ll_uint64_rshift(vli, 7);
		++i;
	} while (!ll_uint64_iszero(vli));

	assert(i <= LZMA_VLI_BYTES_MAX);
	return i;
}
