/*
 *
 *  \file       main.h
 *  \brief      Miscellaneous declarations
 *
 *  Author:     Lasse Collin
 *
 *  This file has been put into the public domain.
 *  You can do whatever you want with this file.
 */

/* Possible exit status values. These are the same as used by gzip and bzip2. */
#define EXIT_WARNING 2


/*
 * Sets the exit status after a warning or error has occurred. If new_status
 * is EXIT_WARNING and the old exit status was already EXIT_FAILURE, the exit
 * status is not changed.
 */
void set_exit_status(int new_status);


/*
 * Use EXIT_SUCCESS instead of EXIT_WARNING if something worth a warning occurs
 * but nothing worth an error has occurred. This is called when --no-warn
 * is specified.
 */
void set_exit_no_warn(void);
